
var DashboardEvents = function() {
    
    var subjects = {};
    
    var observer = {
        subscribe: function(meta) {
            if (!meta.id || !meta.action) {
                return this;
            }
            if (Array.isArray(meta.id)) {
                meta.id.forEach(function(id) {
                    subjects[id] = (subjects[id] || []).concat(meta.action);
                });
            } else {
                subjects[meta.id] = (subjects[meta.id] || []).concat(meta.action);
            }
            return this;
        },
        
        unsubscribe: function(id) {
            delete subjects[id];
            return this;
        },
        
        ready: function() {
            var iframes = Array.prototype.slice.call(document.getElementsByTagName("iframe"));

            iframes.forEach(function(frame) {
                frame.addEventListener("load", function() {
                    frame.contentWindow.dashboardEvent = function(id, data) {
                        if (!!subjects[id]) {
                            subjects[id].forEach(function(f) {
                                f(data, frame, id);
                            });
                        }
                    };
                });
            });
        }
    };
    
    return observer;
    
};