// OVERRIDE DE STATUSGRIDEVENTS BEHAVIORS


var StatusgridEvents = (function(events) {
    
  var singleAdvancedWindow = null;
  
  function showAdvancedSearch() {
    var metaGridView = Ext.ComponentQuery.query("#gridview").reduce(function(result, cmp) {
        return { viewmodel: cmp.getViewModel(), el: cmp };
    }, {});
      
    if (!singleAdvancedWindow) {
        singleAdvancedWindow = Ext.widget("filterpanel", {
            inputs: [
                {
                    viewModel: metaGridView.viewmodel,
                    width: 200,
                    inputs: [
                        { cmp: "statefilter", params: { bind: { value: "{filter.state}" } } }
                    ]
                },
                { 
                    viewModel: metaGridView.viewmodel,
                    inputs: [
                        { cmp: "date" }, 
                        { cmp: "class", params: { bind: { value: "{filter.class}" } } },
                        { cmp: "type", params: { bind: { value: "{filter.type}" } } },
                        { cmp: "notificationReason", params: { bind: { value: "{filter.notification_reason}" } } },
                        { cmp: "stateType", params: { bind: { value: "{filter.state_type}" } } }
                    ]
                },
                {
                    viewModel: metaGridView.viewmodel,
                    inputs: [
                        { cmp: "hostName", params: { bind: { value: "{filter.host_name}" } } },
                        { cmp: "hostGroup", params: { bind: { value: "{filter.hostgroup_name}" } } },
                        { cmp: "serviceDescription", params: { bind: { value: "{filter.service_description}" } } },
                        { cmp: "serviceGroup", params: { bind: { value: "{filter.servicegroup_name}" } } },
                        { cmp: "details", params: { bind: { value: "{filter.details}" } } }
                    ]
                }
            ],
            applyHandler: function(filterPanel, values) {
                var dates = Ext.apply({}, values.date || {});
                var cloneValues = Ext.apply({}, values, dates);
                delete cloneValues.date;
                metaGridView.viewmodel.set("filter", cloneValues);
                metaGridView.el.controller.applyFilter();
                filterPanel.hide();
            },
            closeHandler: function() {
                metaGridView.viewmodel.set("filter", metaGridView.viewmodel.get("filterToSend") || {});
            },
            renderTo: Ext.getBody()
        });
    }
      
    singleAdvancedWindow.down("daterangefield").setValue(metaGridView.viewmodel.data.filterToSend);
      
    singleAdvancedWindow.show();
      
    var filter = metaGridView.viewmodel.data.filter;
    
    singleAdvancedWindow.query("combodsfilter").forEach(function(el) {
        if (filter[el.getName()] !== null) {
            el.getStore().load();
        }
    });
  }
    
  var cancelSearch = function(e) {
      var controller = Ext.ComponentQuery.query("#gridview").reduce(function(result, cmp) {
          return cmp.getController();
      }, null);
      controller.changeToRealtime();
  };
    
  var applyMessageFilter = function(event) {
      if (event) { event.preventDefault(); }
      Ext.ComponentQuery.query("#gridview").forEach(function(grid) {
          var viewmodel = grid.getViewModel();
          var value = parent.document.querySelector('input[name="filter[search]"]').value;
          if (value && value.length) {
              viewmodel.set("filter", { search: value });
              grid.controller.applyFilter();
          } else {
              var clone = Ext.clone(viewmodel.data.filterToSend);
              delete clone.search;
              viewmodel.set("filter", Ext.apply(clone));
              grid.controller.applyFilter();
          }
      });
  };

  return {
      showAdvancedSearch: showAdvancedSearch,
      singleAdvancedWindow: function() {
          return singleAdvancedWindow;
      },
      cancelSearch: cancelSearch,
      applyMessageFilter: applyMessageFilter,
  };
})(StatusgridEvents);

function adjustIE10Style() {
}

function createYestardayDate() {
    var dt = new Date(Date.now());
    return dt.setDate(dt.getDate() - 1);
}

function createAMonth() {
    var dt = new Date();
    return dt.setDate(dt.getDate() - 31);
}

var ajustDate = function(d) { return Math.floor(new Date(d).getTime() / 1000); };
