var gridFilters = (function() {
    
    var state = {
        width: 200,
        inputs: [
            { cmp: "statefilter" }
        ]
    };

    var hostServiceColumn = [
        { cmp: "hostName" },
        { cmp: "hostGroup" },
        { cmp: "serviceDescription" },
        { cmp: "serviceGroup" },
        { cmp: "details" }
    ];
    
    var address = { cmp: "textfield", params: { name: "address", fieldLabel: optranslate.translate('Address') } };

    var rightColumn = [
        {
            cmp: "combobox",
            params: {
                store: Ext.create("Ext.data.Store", {
                    data: [
                        {
                            label: optranslate.translate('All'),
                            value: "-1"
                        },
                        {
                            label: optranslate.translate('Only soft state'),
                            value: "0"
                        },
                        {
                            label: optranslate.translate('Only hard state'),
                            value: "1"
                        }
                    ]
                }),
                name: "state_type",
                displayField: "label",
                valueField: "value",
                fieldLabel: optranslate.translate('Level')
            }
        },
        {
            cmp: "combobox",
            params: {
                store: "combo.EnabledDisabled",
                name: "active_checks_enabled",
                displayField: "label",
                valueField: "value",
                fieldLabel: optranslate.translate('Checks')
            }
        },
        {
            cmp: "combobox",
            params: {
                store: "combo.EnabledDisabled",
                name: "notifications_enabled",
                displayField: "label",
                valueField: "value",
                fieldLabel: optranslate.translate('Notification')
            }
        },
        {
            cmp: "combobox",
            params: {
                store: "combo.WithWithout",
                name: "documentation",
                displayField: "label",
                valueField: "value",
                fieldLabel: optranslate.translate('Documentation')
            }
        },
        {
            cmp: "fieldcontainer",
            params: {
                items: [{
                    xtype: "checkboxfield",
                    name: "priorityOrder",
                    boxLabel: optranslate.translate('Order by priority'),
                    inputValue: "1"
                }],
                getValue: function() {
                    return this.down("checkboxfield").getValue();
                },
                getName: function() {
                    return "priorityOrder";
                }
            }
        }
    ];
    
    var applyFilterInState = function(f) {
        return Ext.apply(
            {},
            {
                inputs: state.inputs.map(function(input) {
                    return Ext.apply({}, input, { params: { filterFn: f }} );
                })
            },
            state
        );
    };
    
    var hostMeta = [
        applyFilterInState(function(rec) {
            var state = Number(rec.get("state"));
            return !(state > 3 && state < 7);
        }),
        { inputs: hostServiceColumn.slice(0, 2).concat(address).concat(hostServiceColumn.slice(-1)) },
        { inputs: rightColumn }
    ];
    
    var inputsMap = {
        service: [
            state,
            { inputs: hostServiceColumn },
            { inputs: rightColumn }
        ],
        servicegroup: [
            applyFilterInState(function(rec) {
                var state = Number(rec.get("state"));
                return state < 7;
            }),
            { inputs: hostServiceColumn.slice(0, 1).concat(hostServiceColumn.slice(2)) },
            { inputs: rightColumn }
        ],
        host: hostMeta,
        hostgroup: hostMeta,
    };
    
    return {
        mount: function(key) {
            return inputsMap[key];
        }
    };
    
}) ();