var DashHelp = (function() {
    
    var createLoadingEffect = function(store, element) {
        var loading = element.component.query("#loading");
        var refresh = element.component.query("#refresh");
        var store = Ext.getStore(store);
        
        store.lastUpdate = op.Maybe.Nothing;

        store.on("beforeload", function() {
            op.List.zip(function(loading, refresh) {
                loading.setHidden(false);
                refresh.setHidden(true);
            }) (loading, refresh);
        });

        store.on("load", function() {
            store.lastUpdate = op.Maybe.Just(Date.now());
            op.List.zip(function(loading, refresh) {
                setTimeout(function() {
                    loading.setHidden(true);
                    refresh.setHidden(false);
                }, 2000);
            }) (loading, refresh);
        });
    };
    
    var verifyStillLogged = function() {
        var ssid = getCookie("PHPSESSID");
        if (!ssid) {
            parent.window.location = "/";
            return false;
        }
        return true;
    };
    
    var diffDate = (function(oneDay) {
        return function(date) {
            var now = new Date();
            var to = new Date(Number(date) * 1000);
            return Math.round(Math.abs((to.getTime() - now.getTime()) / oneDay));
        };
    }) (24*60*60*1000);
    
    var colorsBase = ['#bf4450', '#ffba42'];
    
    var getColorBase = function(date, limit) {
        limit = limit || 10;
        return diffDate(date) <= limit ? colorsBase[0] : colorsBase[1];
    };
    
    return {
        createLoadingEffect: createLoadingEffect,
        verifyStillLogged: verifyStillLogged,
        diffDate: diffDate,
        colorsBase: colorsBase,
        getColorBase: getColorBase
    };
    
}) ();